package cn.ysk.cashier.controller.shop;

import cn.ysk.cashier.annotation.Log;
import cn.ysk.cashier.pojo.shop.TbShopUnit;
import cn.ysk.cashier.service.shop.TbShopUnitService;
import cn.ysk.cashier.dto.shop.TbShopUnitQueryCriteria;
import org.springframework.data.domain.Pageable;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.*;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

@RestController
@RequiredArgsConstructor
@Api(tags = "/shop/unit管理")
@RequestMapping("/api/tbShopUnit")
public class TbShopUnitController {

    private final TbShopUnitService tbShopUnitService;

    @ApiOperation("导出数据")
    @GetMapping(value = "/download")
    @PreAuthorize("@el.check('tbShopUnit:list')")
    public void exportTbShopUnit(HttpServletResponse response, TbShopUnitQueryCriteria criteria) throws IOException {
        tbShopUnitService.download(tbShopUnitService.queryAll(criteria), response);
    }

    @GetMapping
    @ApiOperation("查询/shop/unit")
    public ResponseEntity<Object> queryTbShopUnit(TbShopUnitQueryCriteria criteria, Pageable pageable){
        return new ResponseEntity<>(tbShopUnitService.queryAll(criteria,pageable),HttpStatus.OK);
    }

    @PostMapping
    @Log("新增单位:#resources.name")
    @ApiOperation("新增/shop/unit")
    public ResponseEntity<Object> createTbShopUnit(@Validated @RequestBody TbShopUnit resources){
        return new ResponseEntity<>(tbShopUnitService.create(resources),HttpStatus.CREATED);
    }

    @PutMapping
    @Log("修改单位:#resources.name")
    @ApiOperation("修改/shop/unit")
    public ResponseEntity<Object> updateTbShopUnit(@Validated @RequestBody TbShopUnit resources){
        tbShopUnitService.update(resources);
        return new ResponseEntity<>(HttpStatus.NO_CONTENT);
    }

    @DeleteMapping
    @Log("删除单位:#ids")
    @ApiOperation("删除/shop/unit")
    public ResponseEntity<Object> deleteTbShopUnit(@RequestBody Integer[] ids) {
        tbShopUnitService.deleteAll(ids);
        return new ResponseEntity<>(HttpStatus.OK);
    }
}